{$A+,B-,D-,E-,F-,G+,I-,L-,N-,O-,P-,Q-,R-,S-,T-,V-,X+,Y-}
{$M 8192,0,655360}

USES StringManipulation;

TYPE
	PCharacterString = ^TCharacterString;
	TCharacterString = RECORD
		Value: ^String;
		Next: PCharacterString;
	END;

	PCharacterText = ^TCharacterText;
	TCharacterText = RECORD
		Weight: Integer;
		Strings: PCharacterString;
		Next: PCharacterText;
	END;

CONST
	CharacterTextsFileName = 'destisqr.dta';
	CharacterIdentifier = '#';

	PrinterWidth = 78;

	MonthNames: ARRAY[1..12] OF String [8] = (
		'ﭢ', '䥢ࠫ', '', '५', '', '',
		'', '', 'ᥭ', '', '', '');

VAR
	ProgramPath: String;
	CurrentDay: Integer;
	CurrentMonth: Integer;
	CurrentYear: Integer;
	IncarnationNumber: Integer;
	CharacterWeights: ARRAY[1..9] OF Integer;
	CharacterTexts: ARRAY[1..9] OF PCharacterText;

PROCEDURE ErrorExit (Message: String);
BEGIN
	WriteLn (Message);
	Halt;
END;

VAR
	PrinterStringLeft: String;

PROCEDURE PrinterInitialize;
BEGIN
	PrinterStringLeft := '';
END;

PROCEDURE PrinterPrintString (InString: String);
VAR
	i: Integer;
	NewWord: String;
BEGIN
	FOR i := 1 TO StringWordCount (InString, ' ') DO
		BEGIN
			NewWord := StringWordGet (InString, ' ', i);

			IF (Length (NewWord) + 1 > PrinterWidth) THEN
				ErrorExit (' ᯥ ப! ⨫ ᫨誮  ᫮!');

			IF (Length (PrinterStringLeft) + Length (NewWord) + 1 > PrinterWidth) THEN
				BEGIN
					WriteLn (PrinterStringLeft);
					PrinterStringLeft := NewWord;
				END
			ELSE
				BEGIN
					IF (PrinterStringLeft <> '') THEN
						PrinterStringLeft := PrinterStringLeft + ' ';

					PrinterStringLeft := PrinterStringLeft + NewWord;
				END;
		END;
END;

PROCEDURE PrinterFinish;
BEGIN
	IF (PrinterStringLeft <> '') THEN
		WriteLn (PrinterStringLeft);
END;

PROCEDURE TitleShow;
BEGIN
	WriteLn ('" "  ᫮ ⥬ 䠣.');
	WriteLn;
	WriteLn ('ࠪ 祫, த襣 ', CurrentDay, ' ', MonthNames [CurrentMonth], ' ', CurrentYear, ' :');
	WriteLn;
	WriteLn (CharReplicate ('-', 78));
END;

PROCEDURE CopyrightShow;
BEGIN
	WriteLn (CharReplicate ('-', 78));
	WriteLn;
	WriteLn ('஢ ணࠬ DESTISQR.EXE (c) 1997 Seaber Designs');
	WriteLn;
END;

PROCEDURE DateCheck;
VAR
	LeapYear: Boolean;
BEGIN
	LeapYear := (NOT Boolean (CurrentYear MOD 4)) AND
		((Boolean (CurrentYear MOD 100)) OR ((NOT Boolean (CurrentYear MOD 100)) AND (NOT Boolean (CurrentYear MOD 400))));

	IF (CurrentYear < 0) OR (CurrentYear > 3500) OR (CurrentMonth < 1) OR (CurrentMonth > 12) OR (CurrentDay < 1) OR
		((CurrentMonth = 2) AND (((LeapYear) AND (CurrentDay > 28)) OR ((NOT LeapYear) AND (CurrentDay > 29)))) OR
		((CurrentMonth <> 2) AND (CurrentDay > (31 - (((CurrentMonth - 1) MOD 7) MOD 2)))) THEN
		BEGIN
			WriteLn ('   ୠ!');
			WriteLn;
			WriteLn ('⨬ 祭  -  0  3500.');
			WriteLn ('᫠   ᮮ⢥⢮ !');
			Halt;
		END;
END;

PROCEDURE DateLoad;
VAR
	i: Integer;
BEGIN
	Val (ParamStr (1), CurrentDay, i);

	IF (i <> 0) THEN
		ErrorExit (' ࠬ [᫮]  㪠 ୮ ᫮!');

	Val (ParamStr (2), CurrentMonth, i);

	IF (i <> 0) THEN
		ErrorExit (' ࠬ []  㪠 ୮ ᫮!');

	Val (ParamStr (3), CurrentYear, i);

	IF (i <> 0) THEN
		ErrorExit (' ࠬ []  㪠 ୮ ᫮!');
END;

FUNCTION StringWeightCalculate (InString: String): Integer;
VAR
	i, j: Integer;
BEGIN
	j := 0;

	FOR i := 1 TO Length (InString) DO
		j := j + Ord (InString [i]) - 48;

	StringWeightCalculate := j;
END;

FUNCTION StringZerosRemove (InString: String): String;
VAR
	i: Integer;
	OutString: String;
BEGIN
	i := 0;
	OutString := InString;

	WHILE (CharPos ('0', OutString, i) <> 0) DO
		BEGIN
			i := CharPos ('0', OutString, i) - 1;
			OutString := StringRemove (OutString, i, 1);
		END;

	StringZerosRemove := OutString;
END;

PROCEDURE DateCalculate;
VAR
	i, j, k, l, m: Integer;
	s1, s2, s3, s4: String;
	FirstString: String;
BEGIN
	FOR i := 1 TO 9 DO
		CharacterWeights [i] := 0;

	Str (CurrentDay, s1);
	Str (CurrentMonth, s2);
	Str (CurrentYear, s3);

	FirstString := s1 + s2 + s3;
	j := StringWeightCalculate (FirstString);

	Str (j, s4);
	k := StringWeightCalculate (s4);

	Val (FirstString [1], i, l);
	l := j - i * 2;

	Str (l, s4);
	m := StringWeightCalculate (s4);

	Str (j, s1);
	Str (k, s2);
	Str (l, s3);
	Str (m, s4);

	FirstString := StringZerosRemove (FirstString) + StringZerosRemove (s1 + s2 + s3 + s4);
	IncarnationNumber := Length (FirstString);

	FOR i := 1 TO Length (FirstString) DO
		BEGIN
			j := Ord (FirstString [i]) - 48;
			CharacterWeights [j] := CharacterWeights [j] + 1;
		END;
END;

PROCEDURE CharacterTextsLoad;
VAR
	i, j: Integer;
	InFile: Text;
	InString: String;
	CurrentString: PCharacterString;
	CurrentCharacter: PCharacterText;
	PreviousCharacter: PCharacterText;
	NewString: PCharacterString;
BEGIN
	CurrentString := NIL;

	FileMode := 0;
	Assign (InFile, ProgramPath + CharacterTextsFileName);
	Reset (InFile);

	IF (IOResult <> 0) THEN
		ErrorExit ('  䠩 ᠭ ࠪ஢! (' + CharacterTextsFileName + ')');

	FOR i := 1 TO 9 DO
		CharacterTexts [i] := NIL;

	WHILE (NOT Eof (InFile)) DO
		BEGIN
			ReadLn (InFile, InString);

			InString := StringTrimAll (InString, ' '#9);

			IF (InString [1] = CharacterIdentifier) THEN
				BEGIN
					Val (StringWordGet (InString, CharacterIdentifier, 1), i, j);

					IF (j <> 0) OR (i < 1) OR (i > 9) THEN
						ErrorExit ('  䠩 ᠭ ࠪ஢ ०!');

					PreviousCharacter := NIL;
					CurrentCharacter := CharacterTexts [i];

					WHILE (CurrentCharacter <> NIL) DO
						BEGIN
							PreviousCharacter := CurrentCharacter;
							CurrentCharacter := CurrentCharacter^.Next;
						END;

					New (CurrentCharacter);
					CurrentCharacter^.Next := NIL;

					IF (PreviousCharacter <> NIL) THEN
						PreviousCharacter^.Next := CurrentCharacter
					ELSE
						CharacterTexts [i] := CurrentCharacter;

					CurrentCharacter^.Weight := Length (StringWordGet (InString, CharacterIdentifier, 2));
					CurrentCharacter^.Strings := New (PCharacterString);
					CurrentCharacter^.Strings^.Value := NIL;
					CurrentCharacter^.Strings^.Next := NIL;

					CurrentString := CurrentCharacter^.Strings;
				END
			ELSE
				IF (CurrentString <> NIL) AND (Length (InString) > 0) THEN
					BEGIN
						NewString := New (PCharacterString);
						NewString^.Value := NIL;
						NewString^.Next := NIL;

						GetMem (CurrentString^.Value, Length (InString) + 1);
						CurrentString^.Value^ := InString;
						CurrentString^.Next := NewString;
						CurrentString := NewString;
					END;
		END;

	Close (InFile);
END;

PROCEDURE CharacterStringsPrint (CharacterStrings: PCharacterString);
VAR
	CurrentCharacterString: PCharacterString;
BEGIN
	CurrentCharacterString := CharacterStrings;

	WHILE (CurrentCharacterString <> NIL) DO
		BEGIN
			IF (CurrentCharacterString^.Value <> NIL) THEN
				PrinterPrintString (CurrentCharacterString^.Value^);

			CurrentCharacterString := CurrentCharacterString^.Next;
		END;
END;

PROCEDURE CharacterPrint (CharacterCell, Weight: Integer);
VAR
	CurrentCharacterText: PCharacterText;
	WeightMin, WeightMax: Integer;
	CharacterTextMin: PCharacterText;
	CharacterTextMax: PCharacterText;
BEGIN
	CurrentCharacterText := CharacterTexts [CharacterCell];
	CharacterTextMin := NIL;
	CharacterTextMax := NIL;
	WeightMin := 32767;
	WeightMax := 0;

	WHILE (CurrentCharacterText <> NIL) DO
		BEGIN
			IF (CurrentCharacterText^.Weight = Weight) THEN
				BEGIN
					CharacterStringsPrint (CurrentCharacterText^.Strings);
					Exit;
				END;

			IF (CurrentCharacterText^.Weight >= WeightMax) THEN
				BEGIN
					CharacterTextMax := CurrentCharacterText;
					WeightMax := CurrentCharacterText^.Weight;
				END;

			IF (CurrentCharacterText^.Weight <= WeightMin) THEN
				BEGIN
					CharacterTextMin := CurrentCharacterText;
					WeightMin := CurrentCharacterText^.Weight;
				END;

			CurrentCharacterText := CurrentCharacterText^.Next;
		END;

	IF (Weight > WeightMax) THEN
		BEGIN
			IF (CharacterTextMax <> NIL) THEN
				CharacterStringsPrint (CharacterTextMax^.Strings);
		END
	ELSE
		IF (Weight < WeightMin) THEN
			BEGIN
				IF (CharacterTextMin <> NIL) THEN
					CharacterStringsPrint (CharacterTextMin^.Strings);
			END;
END;

PROCEDURE CharacterTextShow;
VAR
	i, j: Integer;
BEGIN
	PrinterInitialize;
	WriteLn;
	WriteLn (', ⭮,  ', IncarnationNumber, ' ୠ (饭).');
	WriteLn;

	FOR i := 1 TO 9 DO
		BEGIN
			CharacterPrint (i, CharacterWeights [i]);
		END;

	PrinterFinish;
	WriteLn;
END;

BEGIN
	IF (ParamCount < 3) THEN
		BEGIN
			WriteLn ('DESTISQR.EXE v1.0 (c) 1997 Seaber Designs');
			WriteLn ('Written by Aleksey V. Vaneev');
			WriteLn;
			WriteLn ('" "  ᫮ ⥬ 䠣.');
			WriteLn;
			WriteLn ('ᯮ짮 ணࠬ: DESTISQR.EXE [᫮] [] []');
			WriteLn;
			WriteLn ('ਬ: DESTISQR.EXE 31 12 1985');
			WriteLn ('  ࠪ 祫, த襣 31  1985 .');
			Halt;
		END;

	ProgramPath := StringExtract (ParamStr (0), 0, StringWordPos (ParamStr (0), '\', StringWordCount (ParamStr (0), '\')) - 1);

	CharacterTextsLoad;

	DateLoad;
	DateCheck;
	DateCalculate;

	TitleShow;
	CharacterTextShow;
	CopyrightShow;
END.